OGRE: Ogre::ExternalTextureSource Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ExternalTextureSource Class Reference

IMPORTANT: **Plugins must override default dictionary name!** Base class that texture plugins derive from. More...

`#include <OgreExternalTextureSource.h>`

Inheritance diagram for Ogre::ExternalTextureSource:

[legend]
List of all members.

## Public Member Functions

| ExternalTextureSource ()
| Constructor.
virtual | ~ExternalTextureSource ()
| Virtual destructor.
void | setInputName (String sIN)
| Sets an input file name - if needed by plugin.
const String & | getInputName () const
| Gets currently set input file name.
void | setFPS (int iFPS)
| Sets the frames per second - plugin may or may not use this.
const int | getFPS () const
| Gets currently set frames per second.
void | setPlayMode (eTexturePlayMode eMode)
| Sets a play mode.
eTexturePlayMode | getPlayMode () const
| Gets currently set play mode.
void | setTextureTecPassStateLevel (int t, int p, int s)
| Used for attaching texture to Technique, State, and texture unit layer.
void | getTextureTecPassStateLevel (int &t, int &p, int &s) const
| Get currently selected Textute attribs.
void | addBaseParams ()
| Call from derived classes to ensure the dictionary is setup.
const String & | getPlugInStringName (void) const
| Returns the string name of this PlugIn (as set by the PlugIn).
const String & | getDictionaryStringName (void) const
| Returns dictionary name.
virtual bool | initialise ()=0
| Call this function from manager to init system.
virtual void | shutDown ()=0
| Shuts down PlugIn.
virtual void | createDefinedTexture (const String &sMaterialName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)=0
| Creates a texture into an already defined material or one that is created new (it's up to plugin to use a material or create one) Before calling, ensure that needed params have been defined via the stringInterface or regular methods.
virtual void | destroyAdvancedTexture (const String &sTextureName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)=0
| What this destroys is dependent on the plugin...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Member Functions

bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

String | mPlugInName
| Command for setting the tecnique, pass, & state level String Name of this PlugIn.
eTexturePlayMode | mMode
String | mInputFileName
bool | mUpdateEveryFrame
int | mFramesPerSecond
int | mTechniqueLevel
int | mPassLevel
int | mStateLevel
String | mDictionaryName
| The string name of the dictionary name - each plugin must override default name.
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

static CmdInputFileName | msCmdInputFile
static CmdFPS | msCmdFramesPerSecond
| Command for setting input file name.
static CmdPlayMode | msCmdPlayMode
| Command for setting frames per second.
static CmdTecPassState | msCmdTecPassState
| Command for setting play mode.
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Classes

class | CmdFPS
class | CmdInputFileName
class | CmdPlayMode
class | CmdTecPassState

## Detailed Description

IMPORTANT: **Plugins must override default dictionary name!** Base class that texture plugins derive from.

Any specific requirements that the plugin needs to have defined before texture/material creation must be define using the stringinterface before calling create defined texture... or it will fail, though, it is up to the plugin to report errors to the log file, or raise an exception if need be.

Definition at line 68 of file OgreExternalTextureSource.h.

## Constructor & Destructor Documentation

Ogre::ExternalTextureSource::ExternalTextureSource | ( |  | ) |

| Constructor.

virtual Ogre::ExternalTextureSource::~ExternalTextureSource | ( |  | ) | `[virtual]`

| Virtual destructor. Definition at line 74 of file OgreExternalTextureSource.h.

## Member Function Documentation

void Ogre::ExternalTextureSource::addBaseParams | ( |  | ) |

| Call from derived classes to ensure the dictionary is setup.

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs.

virtual void Ogre::ExternalTextureSource::createDefinedTexture | ( | const String & | sMaterialName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[pure virtual]`

| Creates a texture into an already defined material or one that is created new (it's up to plugin to use a material or create one) Before calling, ensure that needed params have been defined via the stringInterface or regular methods.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

virtual void Ogre::ExternalTextureSource::destroyAdvancedTexture | ( | const String & | sTextureName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[pure virtual]`

| What this destroys is dependent on the plugin... See specific plugin doc to know what is all destroyed (normally, plugins will destroy only what they created, or used directly - ie. just texture unit)

const String& Ogre::ExternalTextureSource::getDictionaryStringName | ( | void |  | ) | const

| Returns dictionary name. Definition at line 134 of file OgreExternalTextureSource.h.

const int Ogre::ExternalTextureSource::getFPS | ( |  | ) | const

| Gets currently set frames per second. Definition at line 115 of file OgreExternalTextureSource.h.

const String& Ogre::ExternalTextureSource::getInputName | ( |  | ) | const

| Gets currently set input file name. Definition at line 111 of file OgreExternalTextureSource.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 213 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

eTexturePlayMode Ogre::ExternalTextureSource::getPlayMode | ( |  | ) | const

| Gets currently set play mode. Definition at line 119 of file OgreExternalTextureSource.h.

const String& Ogre::ExternalTextureSource::getPlugInStringName | ( | void |  | ) | const

| Returns the string name of this PlugIn (as set by the PlugIn). Definition at line 132 of file OgreExternalTextureSource.h.

void Ogre::ExternalTextureSource::getTextureTecPassStateLevel | ( | int & | t,
|  | int & | p,
|  | int & | s
| ) | const

| Get currently selected Textute attribs. Definition at line 125 of file OgreExternalTextureSource.h.

virtual bool Ogre::ExternalTextureSource::initialise | ( |  | ) | `[pure virtual]`

| Call this function from manager to init system.

void Ogre::ExternalTextureSource::setFPS | ( | int | iFPS | ) |

| Sets the frames per second - plugin may or may not use this. Definition at line 113 of file OgreExternalTextureSource.h.

void Ogre::ExternalTextureSource::setInputName | ( | String | sIN | ) |

| Sets an input file name - if needed by plugin. Definition at line 109 of file OgreExternalTextureSource.h.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::ExternalTextureSource::setPlayMode | ( | eTexturePlayMode | eMode | ) |

| Sets a play mode. Definition at line 117 of file OgreExternalTextureSource.h.

void Ogre::ExternalTextureSource::setTextureTecPassStateLevel | ( | int | t,
|  | int | p,
|  | int | s
| ) |

| Used for attaching texture to Technique, State, and texture unit layer. Definition at line 122 of file OgreExternalTextureSource.h.

virtual void Ogre::ExternalTextureSource::shutDown | ( |  | ) | `[pure virtual]`

| Shuts down PlugIn.

## Member Data Documentation

String Ogre::ExternalTextureSource::mDictionaryName`[protected]`

| The string name of the dictionary name - each plugin must override default name. Definition at line 180 of file OgreExternalTextureSource.h.

int Ogre::ExternalTextureSource::mFramesPerSecond`[protected]`

| Definition at line 171 of file OgreExternalTextureSource.h.

String Ogre::ExternalTextureSource::mInputFileName`[protected]`

| Definition at line 167 of file OgreExternalTextureSource.h.

eTexturePlayMode Ogre::ExternalTextureSource::mMode`[protected]`

| Definition at line 165 of file OgreExternalTextureSource.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 164 of file OgreStringInterface.h.

int Ogre::ExternalTextureSource::mPassLevel`[protected]`

| Definition at line 171 of file OgreExternalTextureSource.h.

String Ogre::ExternalTextureSource::mPlugInName`[protected]`

| Command for setting the tecnique, pass, & state level String Name of this PlugIn. Definition at line 162 of file OgreExternalTextureSource.h.

CmdFPS Ogre::ExternalTextureSource::msCmdFramesPerSecond`[static, protected]`

| Command for setting input file name. Definition at line 156 of file OgreExternalTextureSource.h.

CmdInputFileName Ogre::ExternalTextureSource::msCmdInputFile`[static, protected]`

| Definition at line 155 of file OgreExternalTextureSource.h.

CmdPlayMode Ogre::ExternalTextureSource::msCmdPlayMode`[static, protected]`

| Command for setting frames per second. Definition at line 157 of file OgreExternalTextureSource.h.

CmdTecPassState Ogre::ExternalTextureSource::msCmdTecPassState`[static, protected]`

| Command for setting play mode. Definition at line 158 of file OgreExternalTextureSource.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 161 of file OgreStringInterface.h.

int Ogre::ExternalTextureSource::mStateLevel`[protected]`

| Definition at line 171 of file OgreExternalTextureSource.h.

int Ogre::ExternalTextureSource::mTechniqueLevel`[protected]`

| Definition at line 171 of file OgreExternalTextureSource.h.

bool Ogre::ExternalTextureSource::mUpdateEveryFrame`[protected]`

| Definition at line 169 of file OgreExternalTextureSource.h.

The documentation for this class was generated from the following file:

- OgreExternalTextureSource.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:44 2008